package nc.bs.pmpub.pfxx.plugin;

import nc.bs.framework.common.NCLocator;
import nc.bs.pfxx.ISwapContext;
import nc.itf.pmpub.project.pub.IProjectServiceForPu;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.vo.pfxx.auxiliary.AggxsysregisterVO;
import nc.vo.pmpub.project.ProjectHeadVO;
import nc.vo.pub.BusinessException;

public class ProjectPfxxPlugin extends nc.bs.pfxx.plugin.AbstractPfxxPlugin{
 /**
  * 
  * Ŀ
  * 
  */
	
	private IProjectServiceForPu iproservice = null;
	private IUAPQueryBS iuap = null;

    private IProjectServiceForPu getiTeamMaintainService() {
        if (this.iproservice == null) {
            this.iproservice = NCLocator.getInstance().lookup(IProjectServiceForPu.class);
        }
        return this.iproservice;

    }
    
    private IUAPQueryBS getIuap() {
        if (this.iuap == null) {
            this.iuap = NCLocator.getInstance().lookup(IUAPQueryBS.class);
        }
        return this.iuap;

    }
    
	@Override
	protected Object processBill(Object vo, ISwapContext swapContext,
			AggxsysregisterVO aggvo) throws BusinessException {
		if (vo == null)
  	      throw new BusinessException(nc.vo.ml.NCLangRes4VoTransl.getNCLangRes()
  	          .getStrByID("4008001_0", "04008001-0137")/*@res "תvoΪ"*/);
		ProjectHeadVO headvo=(ProjectHeadVO)vo;
		//EPSڵ 
		String sql="select pk_eps  from pm_eps where eps_code='" + headvo.getPk_eps() + "' and enablestate='2' and isnull(dr,0)=0 ";
		Object objpk_eps=getIuap().executeQuery(sql, new ColumnProcessor("pk_eps"));
		headvo.setPk_eps(objpk_eps==null?"":objpk_eps.toString());
		ProjectHeadVO saveheadvo=getiTeamMaintainService().insertProject(headvo);
		String vopk = saveheadvo.getPrimaryKey();
		
		return vopk;
	}
                
}
