package nc.bs.ct.saledaily.pfxx;

import nc.bs.ct.pfxx.AbstractCTPfxxPlugin;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.scmpub.pf.PfParameterUtil;
import nc.impl.ct.saledaily.action.SaledailyDeleteAction;
import nc.impl.ct.saledaily.action.SaledailyInsertAction;
import nc.impl.pubapp.pattern.data.bill.BillQuery;
import nc.itf.uap.pf.IPFBusiAction;
import nc.pubitf.uapbd.CurrencyRateUtil;
import nc.vo.ct.saledaily.entity.AggCtSaleVO;
import nc.vo.ct.saledaily.entity.CtSaleBVO;
import nc.vo.ct.saledaily.entity.CtSaleVO;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDouble;
import nc.vo.scmpub.res.billtype.CTBillType;
import nc.vo.util.CloneUtil;

import java.util.HashMap;

import org.apache.commons.lang.ArrayUtils;

import nc.vo.pubapp.pattern.exception.ExceptionUtils;
import nc.vo.pubapp.pattern.pub.MathTool;
public class Z3PfxxPlugin extends AbstractCTPfxxPlugin {
	private AggregatedValueObject save(AggregatedValueObject vo) {
		AggCtSaleVO aggvo = (AggCtSaleVO) vo;
		
		
		
		/*ֻ */
		
		 /**
	     * ԴĿıѯָڵĻ
	     * 
	     * @param src_currency_pk
	     *            Դ
	     * @param dest_currency_pk
	     *            ĿıֵΪnullʱΪĬĿı
	     * @param date
	     * @return
	     * @throws BusinessException
	     */
		
		CtSaleVO headvo=aggvo.getParentVO();
         if( headvo.getNexchangerate().compareTo(UFDouble.ONE_DBL)!=0){
     		String corigcurrencyid= headvo.getCorigcurrencyid();
     		String ccurrencyid = headvo.getCcurrencyid();
     		CurrencyRateUtil currRateUtil = CurrencyRateUtil
     				.getInstanceByOrg(headvo.getPk_org());
     		try {
     			UFDouble foreignrate = currRateUtil.getRate(corigcurrencyid,
     					ccurrencyid, headvo.getDbilldate());//
     			
     			 headvo.setNexchangerate(foreignrate);
     			
     			CtSaleBVO[]  bodyvos=aggvo.getCtSaleBVO();
     			
     			for(CtSaleBVO bodyvo:bodyvos){
     				//norigprice ԭ˰
     				UFDouble norigprice=bodyvo.getNorigtaxprice();//ԭҺ˰
     				UFDouble foreignAmount=	currRateUtil.getAmountByOpp(corigcurrencyid,
     						ccurrencyid, norigprice, foreignrate, headvo.getDbilldate());
     				bodyvo.setNgtaxprice(foreignAmount);//Һ˰
     				
     				UFDouble ngprice=currRateUtil.getAmountByOpp(corigcurrencyid,
     						ccurrencyid, bodyvo.getNorigprice()/*ԭ˰*/, foreignrate, headvo.getDbilldate());
     				
     				bodyvo.setNgprice(ngprice); // ˰
     				
     				bodyvo.setNqtprice(ngprice); //۱˰
     				
     				bodyvo.setNqttaxprice(foreignAmount);//۱Һ˰
     				
     				
     				UFDouble nmny=currRateUtil.getAmountByOpp(corigcurrencyid,
     						ccurrencyid, bodyvo.getNorigmny()/*ԭ˰*/, foreignrate, headvo.getDbilldate());
     				
     				bodyvo.setNmny(nmny);//˰  
     				
     				UFDouble ntaxmny=currRateUtil.getAmountByOpp(corigcurrencyid,
     						ccurrencyid, bodyvo.getNorigtaxmny()/*ԭҼ˰ϼ*/, foreignrate, headvo.getDbilldate());
     				
     				bodyvo.setNtaxmny(ntaxmny);//ntaxmny Ҽ˰ϼ
     				
     				bodyvo.setNcaltaxmny(nmny);//˰
     				
     				
     				bodyvo.setNtax(ntaxmny.sub(nmny));//˰=˰ϼ-˰
     			}
     			
     		} catch (BusinessException e1) {
     			 ExceptionUtils.wrappException(e1);
                  return null;
     		}
		}
		
		
		this.processBeforeSave(aggvo, CTBillType.SaleDaily.getCode());
		AggCtSaleVO[] billvo = (new SaledailyInsertAction()).insert(new AggCtSaleVO[]{aggvo});
		//2023-05-24 yaoy  ۺͬ漴û
		
		try {
			AggCtSaleVO aggCtSaleVO = (AggCtSaleVO) queryVOByPk(billvo[0].getParent().getAttributeValue("pk_ct_sale").toString());
			String pk_org = aggCtSaleVO.getParentVO().getPk_org();
			//0001V510000000002GEH   Ż				
			if(pk_org != null && (pk_org.equals("0001V510000000002GDX"))){
				HashMap<String, Object> pfparam = new HashMap<String, Object>(); // òڿԶʱť״̬ 
				pfparam.put(PfParameterUtil.ORIGIN_VO_PARAMETER, CloneUtil.deepClone(new AggCtSaleVO[] {aggCtSaleVO})); 
				CtSaleVO headvoSaleVO=aggCtSaleVO.getParentVO();
//				headvoSaleVO.setApprover(headvoSaleVO.getBillmaker());
//				Object[] userObjAry={headvoSaleVO.getBillmaker()};
//				NCLocator.getInstance().lookup(IPFBusiAction.class) .processBatch("APPROVE", "Z3",new AggCtSaleVO[] {aggCtSaleVO}, userObjAry, null, pfparam);
////				InvocationInfoProxy.getInstance().setUserCode("JG0009190");
			    InvocationInfoProxy.getInstance().setUserId(headvoSaleVO.getApprover());
////			    InvocationInfoProxy.getInstance().setGroupId(headvoSaleVO.getPk_group());
				//õݵΪZDRõû
////				headvoSaleVO.setApprover("1001V510000000C8IGOP");
				NCLocator.getInstance().lookup(IPFBusiAction.class) .processBatch("APPROVE", "Z3",new AggCtSaleVO[] {aggCtSaleVO}, null, null, pfparam);
				
				return aggCtSaleVO;
			}
			
			
		} catch (BusinessException e) {
			ExceptionUtils.wrappBusinessException(e.getMessage());
		}
		return billvo[0];
	}

	protected void deleteVO(AggregatedValueObject vo) {
		(new SaledailyDeleteAction()).delete(new AggCtSaleVO[]{(AggCtSaleVO) vo});
	}

	protected AggregatedValueObject insert(AggregatedValueObject vo) {
		return this.save(vo);
	}

	protected AggregatedValueObject queryVOByPk(String voPk) {
		BillQuery<AggCtSaleVO> billquery = new BillQuery(AggCtSaleVO.class);
		AggCtSaleVO[] vos = (AggCtSaleVO[]) billquery.query(new String[]{voPk});
		return ArrayUtils.isEmpty(vos) ? null : vos[0];
	}
}